extproc sh
#!sh
# 
# os2unix version 1.4 by Jun SAWATAISHI <jsawa@attglobal.net>
#
# 
#   Purpose: Rewrite scripts (configure ...) and Makefile.in's 
#            to run configure and make WITHOUT AUTOCONF. 
# 
#            At least you will succeed in 9 of 10. 
#
#   Usage: 
#          In a top source directory
# 
#            x:/source/foo> os2unix -all
#            x:/source/foo> sh configure --help
#            x:/source/foo> sh configure [SOME_ARGUMENT]
#            x:/source/foo> make
#            x:/source/foo> make install prefix=XXX
#           
#
# @@@ Required Executables @@@
#
#   HOBBES=ftp://hobbes.nmsu.edu/pub/os2
#   LEO=ftp://ftp.leo.org/pub/comp/os/os2/leo
#   JSAWA=http://www2s.biglobe.ne.jp/~vtgf3mpr
#
#  GNU find (find.exe)
#      LEO/gnu/systools/gnufind.zip   ; v4.1
#      HOBBES/util/disk/gnufind.zip   ; v4.1
#  GNU sed 
#      LEO/gnu/systools/gnused.zip    ; v2.05
#      HOBBES/apps/editors/gnused.zip ; v3.0
#      JSAWA/gnu/sed.htm              ; v3.02.80
#  GNU grep (grep.exe)
#      HOBBES/util/file/gnugrep.zip    ; v2.0
#      LEO/gnu/systools/gnugrep.zip    ; v2.0 
#      JSAWA/gnu/grep.htm              ; v2.3h or later
#
#  GNU text utilities (cat,cut, head)  ;
#     LEO/gnu/systools/gnututil.zip    ; v1.19
#     HOBBES/util/file/gnututil.zip    ; v1.19
#     JSAWA/gnu/text-util.htm          ; v2.0 or later
#
#  GNU file utilities (chmod)
#     LEO/gnu/systools/gnufutil.zip    ; v3.13
#     HOBBES/util/file/gnufutil.zip    ; v3.13
#     JSAWA/gnu/fileutils.htm          ; v3.16
#
#  file - determine file type          ; v3.30
#      JSAWA/os2unix/file330.zip
#
# Note for web2c source
#       etexdir/etex.mk: change PATH sep ':' to '\;'
#   pdftexdir/pdftex.mk
#         Change pdftexdir/pdftosrc.o:$(srcdir)/pdftexdir/pdftosrc.c
#             to pdftexdir/pdftosrc.o: $(srcdir)/pdftexdir/pdftosrc.c
# 
#
#@@@ You must define SC_DIR @@@
#
#SC_DIR="i:/RedHat/SOURCES"
SC_DIR="os2"
#@@@ user definetions @@@

SED_CONF="${SC_DIR}/os2_convert_configure.sed"
SED_LTMAIN="${SC_DIR}/os2_convert_ltmain.sed"
SED_MK="${SC_DIR}/os2_convert_Makefile_in.sed"
GREP_MK="${SC_DIR}/os2_convert_Makefile_in.grep"
SED_MK1="${SC_DIR}/os2_convert_Makefile_in_lib_prog.sed"
SED_MK2="${SC_DIR}/os2_convert_mk.sed"
SED_PO_MK="${SC_DIR}/os2_convert_Makefile_in_in.sed"
MKSINSTALLDIRS="${SC_DIR}/os2_mkinstalldirs"
MISSING="${SC_DIR}/os2_missing"
#
needed_util="find grep cut sed chmod cat head patch"
#
#
## functions

function do_check
{
if [ ! "${AVOID_EXIT}" = "yes" ] ; then
  if [ ! -f CHMOD_DONE.tmp ] ; then
      chmod  +rw -R * 2>nul
      touch CHMOD_DONE.tmp
  fi
fi

echo "\n"
echo -n "-- Now verifying \`file' utility to determine file type ... "
if ! type file >nul   ; then
     echo "NO\n"
     echo "\t\t Warning: Modifying shell scripts will be avoided. "
     echo "\t\t          You might have to change \`/bin/sh' to \`sh'. \n"
else
     echo "OK\n"
fi
echo -n "-- checking \`os2unix' scripts exist in ${SC_DIR} directory .... "

for os2_script in ${SED_CONF} ${SED_MK} ${GREP_MK} ${SED_MK1} ${SED_MK2}\
         ${SED_PO_MK} ${MKSINSTALLDIRS} ${MISSING}; do
   if [ ! -f ${os2_script} ] ; then
     echo "\n\t Error: ${os2_script} not exist"
     if [ ! "${AVOID_EXIT}" = "yes" ] ; then
       exit 1
     fi
   fi
done

echo  "\n-- verifyig GNU utilities: ${needed_util} .... \n"

for os2_utl in ${needed_util}  ; do
  if [ "${AVOID_EXIT}" = "yes" ] ; then
    echo -n "\t GNU ${os2_utl}"
  fi
  if ! ${os2_utl} --version 2>nul | grep GNU >nul  ; then
    echo  " is not installed: You cannot run this script"
      case ${os2_utl} in 
        find|patch)
          echo "\n\t Your \`${os2_utl}' may be OS/2 default one, not GNU's"
          echo "\t   If you have already installed GNU ${os2_utl},"
          echo "\t   delete or rename OS/2 default program. "
          ;;
        *)
          ;;
      esac
     if [ ! "${AVOID_EXIT}" = "yes" ] ; then
       exit 1
     fi
  else
    if [ "${AVOID_EXIT}" = "yes" ] ; then
        echo -n "\tOK\n"
    fi
  
  fi
done
echo "\n -- Done "
}

function ch_script
{
  if  type file >nul 2>&1 ; then
	  if [ ! -f 00cp_script.tmp ] ; then
	    find . -type f -regex '.*/[^/.]+' ! -name configure ! \
	      -name mkinstalldirs ! -name ltmain.sh -exec file '{}' \; \
	    | grep script |cut -d: -f1 | sed 's@^\(.*\)$@cp.exe -uvp \1 \1.tmp@' \
	           > 00cp_script.tmp
	     cat ./00cp_script.tmp
	     sh ./00cp_script.tmp
	  fi
	    sed 's_^cp.exe \-uvp \(.*\) \(.*\)$_sed s@\/bin\/sh@sh@ \2 > \1_' \
	       00cp_script.tmp > 00convert_script.tmp
		cat 00convert_script.tmp
	    sh ./00convert_script.tmp
  else
  	  echo "A utility file is not installed\n"
  fi
}

function ch_config
{ 
		if [ ! -f CONFIGURE_CHANGED.tmp ] ; then
			find . -name configure -exec cp '{}' '{}'.tmp \; 
			find . -name ltmain.sh -exec cp '{}' '{}'.tmp \; 
			touch CONFIGURE_CHANGED.tmp
		fi
		find . -name configure -exec "sed -f ${SED_CONF} {}.tmp > {}" \; 
		find . -name ltmain.sh -exec "sed -f ${SED_LTMAIN} {}.tmp > {}" \; 
		find . -name 'configure' -o -name 'ltmain.sh' 
}
function ch_makefile
{
		if [ ! -f MAKEFILE_in_CHANGED.tmp ] ; then
			find . -name Makefile.in  -exec "sed -f ${SED_MK} {} > {}.tmp" \;
			find . -name Makefile.in  -exec "cp -vp {}.tmp {}" \;
			find . -iname GNUmakefile -exec "sed -f ${SED_MK} {} > {}.tmp" \;
			find . -iname GNUmakefile  -exec "cp -vp {}.tmp {}" \;
			touch MAKEFILE_in_CHANGED.tmp
		fi
		if [ ! -f MAKEFILE_in_lib_prog_CHANGED.tmp ] ; then
			find . -name Makefile.in  -exec \
			  "grep -l -f ${GREP_MK} {} " \; | \
			  sed  's/^\(.*\)$/sed -f 00SED_MK1.tmp \1.tmp > \1/' \
			                            > MAKEFILE_in_lib_prog_CHANGED.tmp
			cp ${SED_MK1} 00SED_MK1.tmp
			cat MAKEFILE_in_lib_prog_CHANGED.tmp
			sh MAKEFILE_in_lib_prog_CHANGED.tmp
			find . -name Makefile.in -o -iname GNUmakefile
		fi
}
function ch_po_makefile
{
		if [ ! -f MAKEFILE_in_in_CHANGED.tmp ] ; then
			find . -name Makefile.in.in  -exec cp '{}' '{}'.tmp \;
			touch MAKEFILE_in_in_CHANGED.tmp
		fi
		find . -name Makefile.in.in  -exec "sed -f ${SED_PO_MK} {}.tmp > {}" \;
		find . -name 'Makefile.in.in'
}

function do_mkdirs
{
		if [ ! -f MKIN.tmp ] ; then
	      find . -name mkinstalldirs  -exec cp ${MKSINSTALLDIRS} '{}'  \;
		  find . -name mkinstalldirs -print
		fi
		touch MKIN.tmp
}

function do_missing
{
		if [ ! -f MISSING.tmp ] ; then
			if [ -f missing ] ; then
	          mv missing MISSING.tmp
		      cat ${MISSING} MISSING.tmp > missing
		      head -5 missing
			fi
		fi
}


function web2c_mk
{
		if [ ! -f MK_CHANGED.tmp ] ; then
			find . -name '*.mk'  -exec cp '{}' '{}'.tmp \;
			touch MK_CHANGED.tmp
		fi
		find . -name '*.mk'  -exec "sed -f ${SED_MK2} {}.tmp > {}" \;
		find . -name '*.mk**'
}

function web2c_make
{
		if [ ! -f MAKE_CHANGED.tmp ] ; then
			find . -name '*.make'  -exec cp '{}' '{}'.tmp \;
			touch MAKE_CHANGED.tmp
		fi
		find . -name '*.make'  -exec "sed -f ${SED_MK2} {}.tmp > {}" \;
		find . -name '*.make**'
}
function show_help
{
  echo "Option is ALWAYS required"
  echo "   -c  : convert configure and ltmain.sh scripts using"
  echo "           $SED_CONF \n\t\tand $SED_LTMAIN\n"
  echo "   -s  : convert scripts except configure\n"
  echo "   -m  : convert Makefile.in using"
  echo "             $SED_MK"
  echo "         and $SED_MK1"
  echo "                              (for libary/program)\n"
  echo "   -mi : replace \`mkinstalldir' with OS/2 version"
  echo "         and disable \`missising' script"
  echo "   -all: execute all steps above"
  echo "   -mk : convert *.mk (needed for web2c) using"
  echo "           $SED_MK2\n"
  echo "   -clean : clean temporary files"
  echo "   -check : Check required scripts and executables to run this script"
}
## end of functions


if [ -z $1 ] ; then
  show_help
  exit 0
fi


case "$1" in 
	-s)
		do_check
		ch_script
		;;

	-c) 
		do_check
		ch_config
		;;
	-m) 
		do_check
		ch_makefile
		ch_po_makefile
		;;
	-mi) 
		do_check
		do_missing
		do_mkdirs
		;;
	-all)
		do_check
		do_missing
		ch_config
		ch_script
		ch_makefile
		ch_po_makefile
		do_mkdirs
		;;
	-mk) 
		do_check
		web2c_mk
		web2c_make
		;;
	-clean)
		do_check
		find . -name '*~' -o -name '*.tmp' -o -name '*.rej' | xargs rm
	  ;;
	-check)
		AVOID_EXIT=yes
		do_check
	  ;;
	*) echo Unrecognized option ;;
esac


exit 0
#EOF
